(**************************************************************************
* BlockCAD, a program for building with Lego like blocks on the computer
* Copyright (C) 1998  Anders Isaksson
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
* -------------------------------------------------------------------------
* I hope You send me a copy of any important changes/additions You do.
*
* E-mail: isaksson.etuna@ebox.tninet.se
*
**************************************************************************)

unit AddStd;
{
  The unit name is not entirely correct anymore, _all_ blocks, both
  standard (hardcoded) and general (polygon defined) are added/edited
  here!
}

interface

uses
  Windows, Menus, Dialogs, StdCtrls, ExtCtrls, Controls, Classes, Forms,
  Graphics, RXSpin, RXCtrls, LCadPc2, DrawObject
  ;

type

  TAddHard = class(TForm)
    Panel1: TPanel;
    PaintBoxAddStd: TPaintBox;
    Panel2: TPanel;
    btnAddPiece: TRxSpeedButton;
    btnCancel: TRxSpeedButton;
    Panel3: TPanel;
    btnRotLeft: TRxSpeedButton;
    btnRotUp: TRxSpeedButton;
    btnRotDown: TRxSpeedButton;
    btnRotRight: TRxSpeedButton;
    btnZoomOut: TRxSpeedButton;
    btnZoomIn: TRxSpeedButton;
    btnWireBase: TRxSpeedButton;
    spbColor: TRxSpeedButton;
    ColorDialog1: TColorDialog;
    spbDet0: TRxSpeedButton;
    spbDet1: TRxSpeedButton;
    spbDet2: TRxSpeedButton;
    MainMenu1: TMainMenu;
    mmMirror: TMenuItem;
    mmRotate: TMenuItem;
    mmSort: TMenuItem;
    mmMirrorX: TMenuItem;
    mmMirrorY: TMenuItem;
    mmMirrorZ: TMenuItem;
    mmRotateX: TMenuItem;
    mmRotateY: TMenuItem;
    mmRotateZ: TMenuItem;
    mmAdd: TMenuItem;
    mmAddSurface: TMenuItem;
    mmAddVertex: TMenuItem;
    mmCopy: TMenuItem;
    mmCopySurface: TMenuItem;
    mmCopyVertex: TMenuItem;
    N1: TMenuItem;
    mmMirrorAllX: TMenuItem;
    mmMirrorAllY: TMenuItem;
    mmMirrorAllZ: TMenuItem;
    N2: TMenuItem;
    mmRotateAllX: TMenuItem;
    mmRotateAllY: TMenuItem;
    mmRotateAllZ: TMenuItem;
    mmSortCurrent: TMenuItem;
    mmSortAll: TMenuItem;
    Panel4: TPanel;
    Label12: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edtX: TRxSpinEdit;
    edtY: TRxSpinEdit;
    edtZ: TRxSpinEdit;
    lbBlockTypes: TListBox;
    GroupBox2: TGroupBox;
    edtIdent: TEdit;
    Panel5: TPanel;
    PopupMenu1: TPopupMenu;
    pmSort: TMenuItem;
    PopupMenu2: TPopupMenu;
    TransparentOpaque1: TMenuItem;
    Border1: TMenuItem;
    N3: TMenuItem;
    Delete1: TMenuItem;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    lbDrawOrder: TListBox;
    lbCoord: TListBox;
    lbAllPolys: TListBox;
    PopupMenu3: TPopupMenu;
    MenuItem1: TMenuItem;
    PopupMenu4: TPopupMenu;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    Panel6: TPanel;
    labDetail: TLabel;
    btnExtrude: TRxSpeedButton;
    btnAddPolygon: TRxSpeedButton;
    cbDetail: TComboBox;
    spExt: TRxSpinEdit;
    btnTrash: TRxSpeedButton;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    AdjX: TRxSpinEdit;
    AdjY: TRxSpinEdit;
    Label11: TLabel;
    speOctant: TRxSpinEdit;
    btnAddVertex: TRxSpeedButton;
    AdjZ: TRxSpinEdit;
    mmScale: TMenuItem;
    mmScaleXY2: TMenuItem;
    mmScaleZ2: TMenuItem;
    N4: TMenuItem;
    mmScaleXYd2: TMenuItem;
    mmScaleZd2: TMenuItem;
    cbAutoStuds: TCheckBox;
    procedure RadioGroup1Click(Sender: TObject);
    procedure PaintBoxAddStdPaint(Sender: TObject);
    procedure speOctantChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lbDrawOrderClick(Sender: TObject);
    procedure lbAllPolysClick(Sender: TObject);
    procedure ckbTranspClick(Sender: TObject);
    procedure lbDrawOrderDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbDrawOrderDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure btnAddPieceClick(Sender: TObject);
    procedure btnTrashDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure btnTrashDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure btnAddPolygonClick(Sender: TObject);
    procedure lbCoordClick(Sender: TObject);
    procedure AdjXChange(Sender: TObject);
    procedure btnAddVertexClick(Sender: TObject);
    procedure edtXChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnRotLeftClick(Sender: TObject);
    procedure btnRotUpClick(Sender: TObject);
    procedure btnRotDownClick(Sender: TObject);
    procedure btnRotRightClick(Sender: TObject);
    procedure btnZoomInClick(Sender: TObject);
    procedure btnZoomOutClick(Sender: TObject);
    procedure lbAllPolysMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure spbColorClick(Sender: TObject);
    procedure spbDet0Click(Sender: TObject);
    procedure cbDetailChange(Sender: TObject);
    procedure btnExtrudeClick(Sender: TObject);
    procedure pmSortClick(Sender: TObject);
    procedure mmMirrorXClick(Sender: TObject);
    procedure lbCoordMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lbCoordDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure TransparentOpaque1Click(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure Border1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Panel5Resize(Sender: TObject);
    procedure lbCoordKeyPress(Sender: TObject; var Key: Char);
    procedure edtXKeyPress(Sender: TObject; var Key: Char);
    procedure mmRotateXClick(Sender: TObject);
    procedure lbAllPolysKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaintBoxAddStdMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxAddStdMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure mmScaleZ4Click(Sender: TObject);
    procedure mmScaleZd2Click(Sender: TObject);
    procedure cbAutoStudsClick(Sender: TObject);
  private
    { Private declarations }
    LocalPiece: TBlock;
    lrx, lrz: TMyFloat;
    lScale: TMyFloat;
    Shadow: TBitmap;
    edtXShadow,
      edtYShadow,
      edtZShadow: integer;
    procedure CreateFromString(Clone: boolean);
    procedure CreateFromSettings;
    procedure SetWindowSize;
    procedure FillUpData(b: TBlock);
    procedure FillVertexData(px: integer);
  public
    { Public declarations }
    function CurrentBlock: string;
    function ApproxHeight: integer;
    procedure SetBlock(s: string; Clone: boolean);
    procedure SetMode(s1, s2: string);
  end;

var
  AddHard           : TAddHard;

implementation

{$R *.DFM}

uses
  SysUtils, Main, LcadPc1, LcadGnrl, AskFP, Math
  //  ,Debug
  ;

const
  InternalHold      : Boolean = False;
  AdjChanging       : Boolean = False;
  BasePt            : TPoint3D = (x: 0; y: 0; z: 0);
  PieceCodes        = 'BTNCEIRWGO';

  EyePoints         : array[0..7] of TPoint3D = (
    (x: - 1000; y: 1000; z: 1000),
    (x: - 1000; y: - 1000; z: 1000),
    (x: 1000; y: - 1000; z: 1000),
    (x: 1000; y: 1000; z: 1000),
    (x: - 1000; y: 1000; z: - 1000),
    (x: - 1000; y: - 1000; z: - 1000),
    (x: 1000; y: - 1000; z: - 1000),
    (x: 1000; y: 1000; z: - 1000)
    );
var
  CurBlockString    : string;
  fFileName         : string;
  fPartName         : string;
  DrawClass         : TDrawClass;
  OrgClass          : TDrawClass;
  CurPoly,
    CurVert         : integer;
  FromPainting      : boolean;

function Dist3(p1, p2: TPoint3D): TMyFloat;
begin
  Result := (p2.x - p1.x) * (p2.x - p1.x) + (p2.y - p1.y) * (p2.y - p1.y) + (p2.z - p1.z) * (p2.z - p1.z);
end;

function TAddHard.CurrentBlock: string;
begin
  if (Length(edtIdent.Text) > 0) then
    Result := CurBlockString + '|' + edtIdent.Text
  else
    Result := CurBlockString;
end;

procedure TAddHard.SetBlock(s: string; Clone: boolean);
var
  i                 : integer;
begin
  lrx := 60 * DEG2RAD;
  lrz := 30 * DEG2RAD;
  //  lScale := 1.0;

  i := Pos('|', s + '|');
  CurBlockString := Copy(s, 1, i - 1);
  edtIdent.Text := Copy(s, i + 1, 255);
  CreateFromString(Clone);
  CurPoly := -1;
  CurVert := -1;
  InternalHold := True;
  try
    edtX.AsInteger := LocalPiece.pl;
    edtY.AsInteger := LocalPiece.pb;
    edtZ.AsInteger := LocalPiece.ph;
    edtXShadow := edtX.AsInteger;
    edtYShadow := edtY.AsInteger;
    edtZShadow := edtZ.AsInteger;
    lbBlockTypes.ItemIndex := Max(0, Pos(LocalPiece.t, PIECECODES) - 1);
    if LocalPiece is TGeneralBlock then begin
      cbAutoStuds.Checked := false; //(TGeneralBlock(LocalPiece).DrawClass.TopStudCount > 0);
    end
    else begin
      cbAutoStuds.Checked := True;
      cbAutoStuds.Enabled := False;
    end;
    SetWindowSize;
  finally
    InternalHold := False;
  end;
end;

procedure TAddHard.FormShow(Sender: TObject);
begin
  spbDet0Click(spbDet0);
  spbDet0.Down := True;
  if Assigned(LocalPiece) then
    lbBlockTypes.ItemIndex := Max(0, Pos(LocalPiece.t, PIECECODES) - 1);
end;

procedure TAddHard.SetMode(s1, s2: string);
begin
  Caption := s1;
  btnAddPiece.Caption := s2;
end;

function TAddHard.ApproxHeight: integer;
var
  Pts               : array[0..1] of TPoint;
begin
  if Assigned(LocalPiece) then
    with LocalPiece do begin
      SaveTransform;
      Settings.Scale := 0.5;
      rx := 60 * DEG2RAD;
      rz := 30 * DEG2RAD;
      ry := 0;
      Settings.xBase := 0;
      Settings.yBase := 0;
      CalcTransform;
      Transform([Point3D(px, py + pb, pz),
        Point3D(px + pl, py, pz + ph)],
          Pts, 0);
      RecallTransform;
      Result := Abs(Pts[0].y - Pts[1].y) + 10;
    end
  else
    Result := 10;
end;

procedure TAddHard.SetWindowSize;
var
  i                 : integer;
begin
  if (lbBlockTypes.ItemIndex <> 8) then begin { Hardcoded blocks }
    Panel5.Visible := False;
    Width := Panel1.Left + Panel1.Width + 10;
    speOctant.AsInteger := 0;
    spbDet0.Visible := False;
    spbDet1.Visible := False;
    spbDet2.Visible := False;
    spbColor.Visible := False;
    for i := 0 to Pred(MainMenu1.Items.Count) do
      MainMenu1.Items[i].Enabled := False;
  end
  else begin                            { General block }
    Panel5.Visible := True;
    //    Width := Panel5.Left {+ lbCoord.Left + lbCoord.Width} + 10;
    spbDet0.Visible := True;
    spbDet1.Visible := True;
    spbDet2.Visible := True;
    spbColor.Visible := True;
    for i := 0 to Pred(MainMenu1.Items.Count) do
      MainMenu1.Items[i].Enabled := True;
  end;
end;

procedure TAddHard.RadioGroup1Click(Sender: TObject);
begin
  if InternalHold then
    Exit;
  SetWindowSize;
  CreateFromSettings;
  if (lbBlockTypes.ItemIndex = 8) then begin { General block }
    InternalHold := True;
    try
      edtX.AsInteger := LocalPiece.pl;
      edtY.AsInteger := LocalPiece.pb;
      edtZ.AsInteger := LocalPiece.ph;
      edtXShadow := edtX.AsInteger;
      edtYShadow := edtY.AsInteger;
      edtZShadow := edtZ.AsInteger;
    finally
      InternalHold := False;
    end;
  end
end;

procedure TAddHard.edtXChange(Sender: TObject);
var
  i, j              : integer;
  p                 : TPoint3D;
  ls, bs, hs        : integer;
  dx, dy, dz        : integer;
begin
  if InternalHold then
    Exit;
  if (lbBlockTypes.ItemIndex <> 8) then begin { Hardcoded blocks }
    CreateFromSettings;
  end
  else begin                            { General block }
    if Assigned(LocalPiece) then begin
      dx := edtX.AsInteger - edtXShadow;
      dy := edtY.AsInteger - edtYShadow;
      dz := edtZ.AsInteger - edtZShadow;
      with TGeneralBlock(LocalPiece), DrawClass do begin
        (* The following code should reside in TDrawClass.SetLBH, I think *)
        ls := pl div 2;
        bs := pb div 2;
        hs := ph div 2;
        for i := 0 to Pred(NumPolys) do begin
          for j := 0 to Pred(NumPoints[i]) do begin
            p := PolyPoint[i, j];
            if (p.x > ls) then
              p.x := p.x + dx;
            if (p.y > bs) then
              p.y := p.y + dy;
            if (p.z > hs) then
              p.z := p.z + dz;
            PolyPoint[i, j] := p;
          end
        end;
        edtXShadow := edtX.AsInteger;
        edtYShadow := edtY.AsInteger;
        edtZShadow := edtZ.AsInteger;
        (*---------------------------------------------------------------*)
        pl := edtX.AsInteger;
        pb := edtY.AsInteger;
        ph := edtZ.AsInteger;
        SetLBH(pl, pb, ph);
        if cbAutoStuds.Checked then
          GenerateStuds(pl, pb, ph);
        if (lbDrawOrder.ItemIndex >= 0) then begin
          px := StrToInt(lbDrawOrder.Items[lbDrawOrder.ItemIndex]) - 1;
          if (px >= 0) then begin
            FillVertexData(px);
          end;
        end;
        PaintBoxAddStdPaint(nil);
      end
    end
  end;
end;

procedure TAddHard.CreateFromSettings;
begin
  if (lbBlockTypes.ItemIndex = 8) then
    CurBlockString := Format('G %s, %s', [fFileName, fPartName])
  else
    CurBlockString := Format('%s %dx%dx%d', [PIECECODES[lbBlockTypes.ItemIndex + 1],
      edtX.AsInteger div PFACTORXY,
        edtY.AsInteger div PFACTORXY,
        edtZ.AsInteger * 3 div PFACTORZ]);
  CreateFromString(False);
  edtIdent.Text := '';
end;

procedure TAddHard.CreateFromString(Clone: boolean);
begin
  if Assigned(LocalPiece) then begin
    LocalPiece.Free;
    LocalPiece := nil;
    DrawClass.Free;
    DrawClass := nil;
    OrgClass := nil;
  end;
  try
    LocalPiece := Main.CreateBlockFromString(CurBlockString);
    LocalPiece.cl := MainForm.ColorIndicator;

    if (LocalPiece is TGeneralBlock) then begin
      DrawClass := TDrawClass.CreateClone(TGeneralBlock(LocalPiece).DrawClass);
      if not Clone then
        OrgClass := TGeneralBlock(LocalPiece).DrawClass
      else
        DrawClass.PrtNam := 'template';
      TGeneralBlock(LocalPiece).DrawClass := DrawClass;
      fFileName := DrawClass.FilNam;
      fPartName := DrawClass.PrtNam;
      FillUpData(LocalPiece);
    end;
    PaintBoxAddStdPaint(nil);
  except
    ;
  end;
end;

const
  ox                : array[0..7] of integer = (60, 60, 60, 60, 120, 120, 120, 120);
  oz                : array[0..7] of integer = (30, 150, 210, 330, 30, 150, 210, 330);

procedure TAddHard.PaintBoxAddStdPaint(Sender: TObject);
var
  Pts               : array[0..3] of TPoint;
  ShadowCanvas      : TDrawObject;
begin
  Shadow.Height := PaintBoxAddStd.ClientHeight;
  Shadow.Width := PaintBoxAddStd.ClientWidth;

  ShadowCanvas := TDrawObject.Create(Shadow);
  try
    ShadowCanvas.Canvas.Brush.Color := AddHard.Color;
    ShadowCanvas.FillRect(PaintBoxAddStd.ClientRect);
    if Assigned(LocalPiece) then begin
      SaveTransform;
      Settings.Scale := lScale;
      rx := lrx;
      rz := lrz;
      ry := 0;
      Settings.xBase := 0;
      Settings.yBase := 0;
      CalcTransform;
      FromPainting := True;
      try
        speOctant.AsInteger := Octant;
      finally
        FromPainting := False;
      end;

      Transform([Point3D(0, 0, 0),
        Point3D(0, 0, 3),
          Point3D(0, 0, PFACTORZ),
          Point3D(LocalPiece.pl, LocalPiece.pb, LocalPiece.ph)],
          Pts, 0);
      zx := Pts[1].x - Pts[0].x;
      zy := Pts[1].y - Pts[0].y;

      zx1 := Pts[2].x - Pts[0].x;
      zy1 := Pts[2].y - Pts[0].y;

      Settings.xBase := (PaintBoxAddStd.Width div 2) - (Pts[3].x div 2);
      Settings.yBase := (PaintBoxAddStd.Height div 2) - (Pts[3].y div 2);

      MainForm.SetStudsIncrement;
      LocalPiece.Draw(ShadowCanvas);
      RecallTransform;
      PaintBoxAddStd.Canvas.Draw(0, 0, Shadow);
    end;
  finally
    ShadowCanvas.Free;
  end
end;

procedure TAddHard.speOctantChange(Sender: TObject);
begin
  if (LocalPiece is TGeneralBlock) then begin
    FillUpData(LocalPiece);
    if not FromPainting then begin
      lrx := ox[speOctant.AsInteger] * DEG2RAD;
      lrz := oz[speOctant.AsInteger] * DEG2RAD;
      PaintBoxAddStdPaint(nil);
    end
  end
end;

procedure TAddHard.FillUpData(b: TBlock);
var
  i                 : integer;
begin
  if Assigned(b) then
    with TGeneralBlock(b).DrawClass do begin
      lbDrawOrder.Items.Clear;
      for i := 0 to Pred(NumDrawFaces[speOctant.AsInteger]) do
        lbDrawOrder.Items.Add(Format('%d', [OrderedFace[speOctant.AsInteger, i] + 1]));
      lbAllPolys.Items.Clear;
      for i := 1 to NumPolys do begin
        if (Border[i - 1] and 1) = 0 then
          lbAllPolys.Items.Add(Format('%d', [-i]))
        else
          lbAllPolys.Items.Add(Format('%d', [i]));
      end;
      btnExtrude.Visible := true;
    end;
  lbCoord.Clear;
end;

procedure TAddHard.FillVertexData(px: integer);
var
  i                 : integer;
  p                 : TPoint3D;
begin
  with TGeneralBlock(LocalPiece).DrawClass do begin
    lbCoord.Items.Clear;
    for i := 0 to Pred(NumPoints[px]) do begin
      p := PolyPoint[px, i];
      lbCoord.Items.Add(Format('%4d%4d%4d', [p.x, p.y, p.z]));
    end;
  end;
end;

procedure TAddHard.lbDrawOrderClick(Sender: TObject);
var
  px                : integer;
begin
  px := StrToInt(lbDrawOrder.Items[lbDrawOrder.ItemIndex]) - 1;
  CurPoly := px;
  CurVert := -1;
  lbAllPolys.ItemIndex := px;
  if Assigned(LocalPiece) and (px >= 0) then begin
    with TGeneralBlock(LocalPiece).DrawClass do begin
      cbDetail.Text := IntToStr(Detail[px]);
      HighLight := px;
      FillVertexData(px);

      AdjChanging := True;
      try
        BasePt := PolyPoint[px, 0];
        AdjX.AsInteger := BasePt.x;
        AdjY.AsInteger := BasePt.y;
        AdjZ.AsInteger := BasePt.z;
      finally
        AdjChanging := False;
      end
    end;
    PaintBoxAddStdPaint(nil);
  end
end;

procedure TAddHard.lbAllPolysClick(Sender: TObject);
var
  px                : integer;
begin
  px := lbAllPolys.ItemIndex;
  CurPoly := px;
  CurVert := -1;
  if Assigned(LocalPiece) and (px >= 0) then begin
    with TGeneralBlock(LocalPiece).DrawClass do begin
      cbDetail.Text := IntToStr(Detail[px]);
      HighLight := px;
      FillVertexData(px);

      AdjChanging := True;
      try
        BasePt := PolyPoint[px, 0];
        AdjX.AsInteger := BasePt.x;
        AdjY.AsInteger := BasePt.y;
        AdjZ.AsInteger := BasePt.z;
      finally
        AdjChanging := False;
      end
    end;
    PaintBoxAddStdPaint(nil);
  end
end;

procedure TAddHard.ckbTranspClick(Sender: TObject);
begin
  if Assigned(LocalPiece) then begin
    LocalPiece.Transp := not LocalPiece.Transp;
    PaintBoxAddStdPaint(nil);
  end;
end;

procedure TAddHard.lbDrawOrderDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := (Source = lbDrawOrder) or (Source = lbAllPolys);
end;

procedure TAddHard.lbDrawOrderDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  p                 : integer;
  i                 : integer;
  Oct               : integer;
  s                 : string;
begin
  if Assigned(LocalPiece) then begin
    if (Source = lbDrawOrder) then begin
      p := lbDrawOrder.ItemAtPos(Point(x, y), False);
      if (p >= 0) and (p < lbDrawOrder.Items.Count) then begin
        Oct := speOctant.AsInteger;
        lbDrawOrder.Items.Move(lbDrawOrder.ItemIndex, p);
        with TGeneralBlock(LocalPiece).DrawClass do begin
          for i := 0 to Pred(lbDrawOrder.Items.Count) do begin
            OrderedFace[Oct, i] := Pred(StrToInt(lbDrawOrder.Items[i]));
          end
        end;
        PaintBoxAddStdPaint(nil);
      end
    end
    else if (Source = lbAllPolys) then begin
      p := lbDrawOrder.ItemAtPos(Point(x, y), False);
      if p >= 0 then begin
        s := TListBox(Source).Items[TListBox(Source).ItemIndex];
        if (s[1] = '-') then
          Delete(s, 1, 1);
        if (lbDrawOrder.Items.IndexOf(s) = -1) then begin
          Oct := speOctant.AsInteger;
          lbDrawOrder.Items.Insert(p, s);
          with TGeneralBlock(LocalPiece).DrawClass do begin
            NumDrawFaces[Oct] := NumDrawFaces[Oct] + 1;
            for i := 0 to Pred(lbDrawOrder.Items.Count) do begin
              OrderedFace[Oct, i] := Pred(StrToInt(lbDrawOrder.Items[i]));
            end
          end;
          PaintBoxAddStdPaint(nil);
        end;
      end
    end;
  end;
end;

procedure TAddHard.btnAddPieceClick(Sender: TObject);
var
  i                 : integer;
begin
  if Assigned(DrawClass) then begin
    DrawClass.HighLight := -1;
    if (DrawClass.FilNam = 'template.dat') or
      (DrawClass.PrtNam = 'template') then begin
      if Length(AskFileAndPart.FileName) = 0 then
        AskFileAndPart.FileName := 'userblks.dat';
      if AskFileAndPart.ShowModal = mrOK then begin
        DrawClass.FilNam := AskFileAndPart.FileName;
        i := Pos('|', AskFileAndPart.PartName);
        if (i > 0) then
          DrawClass.PrtNam := Copy(AskFileAndPart.PartName, 1, i - 1)
        else
          DrawClass.PrtNam := AskFileAndPart.PartName;
        AddDrawClass(DrawClass);
        fFileName := AskFileAndPart.FileName;
        fPartName := AskFileAndPart.PartName;
        CurBlockString := Format('G %s, %s', [fFileName, fPartName])
      end
      else begin
        ModalResult := mrNone;
        Exit;
      end;
    end;
    if Assigned(OrgClass) then begin
      OrgClass.Assign(DrawClass);
      DrawClass.Free;
      DrawClass := nil;
      OrgClass := nil;
    end
    else begin
      DrawClass := nil;
      OrgClass := nil;
    end
  end
end;

procedure TAddHard.btnTrashDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := (Source is TListBox);
end;

procedure TAddHard.Delete1Click(Sender: TObject);
var
  p, i              : integer;
begin
  p := lbAllPolys.ItemIndex;
  with TGeneralBlock(LocalPiece).DrawClass do begin
    i := Pred(Abs(StrToInt(lbAllPolys.Items[p])));
    DeletePoly(i);
    if (CurPoly = i) then begin
      CurPoly := -1;
      CurVert := -1;
    end;
    FillUpData(LocalPiece);
    lbAllPolys.ItemIndex := Min(p, Pred(lbAllPolys.Items.Count));
  end;
  PaintBoxAddStdPaint(nil);
end;

procedure TAddHard.btnTrashDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  Oct               : integer;
  i                 : integer;
begin
  if (Source = lbDrawOrder) then begin  { Remove from drawing order }
    Oct := speOctant.AsInteger;
    lbDrawOrder.Items.Delete(lbDrawOrder.ItemIndex);
    with TGeneralBlock(LocalPiece).DrawClass do begin
      NumDrawFaces[Oct] := NumDrawFaces[Oct] - 1;
      for i := 0 to Pred(lbDrawOrder.Items.Count) do begin
        OrderedFace[Oct, i] := Pred(StrToInt(lbDrawOrder.Items[i]));
      end
    end;
    PaintBoxAddStdPaint(nil);
  end
  else if (Source = lbAllPolys) then begin { Remove polygon completely }
    if MessageDlg('Do You really want to delete'#13#10'this polygon permanently?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      Delete1Click(nil);
    end;
  end
  else if (Source = lbCoord) then begin { Remove vertex from polygon }
    if (CurVert >= 0) then begin
      with TGeneralBlock(LocalPiece).DrawClass do begin
        lbCoord.Items.Delete(CurVert);
        DeletePoint(CurPoly, CurVert);
      end;
      PaintBoxAddStdPaint(nil);
    end
  end
end;

procedure TAddHard.btnAddPolygonClick(Sender: TObject);
begin
  with TGeneralBlock(LocalPiece).DrawClass do begin
    if (CurPoly >= 0) and ((Sender as TComponent).Tag = 0) then
      ClonePoly(CurPoly)
    else
      AddPoly([Point3D(0, 0, 0), Point3D(0, PFACTORXY, 0),
        Point3D(PFACTORXY, PFACTORXY, 0), Point3D(PFACTORXY, 0, 0)]);
    FillUpData(LocalPiece);
    CurPoly := Pred(NumPolys);
    CurVert := -1;
    cbDetail.Text := IntToStr(Detail[CurPoly]);
    lbAllPolys.ItemIndex := CurPoly;
    lbAllPolysClick(nil);
  end;
  PaintBoxAddStdPaint(nil);
end;

procedure TAddHard.lbCoordClick(Sender: TObject);
var
  s                 : string;
begin
  CurVert := lbCoord.ItemIndex;
  s := lbCoord.Items[lbCoord.ItemIndex];
  AdjChanging := True;
  try
    AdjX.Text := Trim(Copy(s, 1, 4));
    AdjY.Text := Trim(Copy(s, 5, 4));
    AdjZ.Text := Trim(Copy(s, 9, 4));
  finally
    AdjChanging := False;
  end;
end;

procedure TAddHard.AdjXChange(Sender: TObject);
var
  i, j              : integer;
  j0, j9            : integer;
  t                 : TPoint3D;
begin
  if not AdjChanging then begin
    if (CurVert >= 0) then begin
      with TGeneralBlock(LocalPiece).DrawClass do begin
        lbCoord.Items[CurVert] := Format('%4d%4d%4d', [AdjX.AsInteger, AdjY.AsInteger, AdjZ.AsInteger]);
        PolyPoint[CurPoly, CurVert] := Point3D(AdjX.AsInteger, AdjY.AsInteger, AdjZ.AsInteger);
      end;
      lbAllPolys.ItemIndex := CurPoly;
      lbCoord.ItemIndex := CurVert;
      PaintBoxAddStdPaint(nil);
    end
    else begin
      with TGeneralBlock(LocalPiece).DrawClass do begin
        if CurPoly < 0 then begin
          Exit;
          {not working yet}
          j0 := 0;
          j9 := Pred(NumPolys);
        end
        else begin
          j0 := CurPoly;
          j9 := CurPoly;
        end;
        for j := j0 to j9 do begin
          for i := 0 to Pred(NumPoints[j]) do begin
            t := PolyPoint[j, i];
            t.x := AdjX.AsInteger - BasePt.x + t.x;
            t.y := AdjY.AsInteger - BasePt.y + t.y;
            t.z := AdjZ.AsInteger - BasePt.z + t.z;
            PolyPoint[j, i] := t;
          end;
          BasePt.x := PolyPoint[j, 0].x;
          BasePt.y := PolyPoint[j, 0].y;
          BasePt.z := PolyPoint[j, 0].z;
        end
      end;
      if Sender = AdjZ then
        with TGeneralBlock(LocalPiece), DrawClass do
          if cbAutoStuds.Checked then
            GenerateStuds(edtX.AsInteger, edtY.AsInteger, edtZ.AsInteger);
      PaintBoxAddStdPaint(nil);
      if CurPoly >= 0 then
        FillVertexData(CurPoly);
    end
  end
end;

procedure TAddHard.btnAddVertexClick(Sender: TObject);
begin
  with TGeneralBlock(LocalPiece).DrawClass do begin
    if (CurVert >= 0) and ((Sender as TComponent).Tag = 0) then begin
      lbCoord.Items.Insert(CurVert, Format('%4d%4d%4d', [AdjX.AsInteger, AdjY.AsInteger, AdjZ.AsInteger]));
      InsertPoint(CurPoly, CurVert, Point3D(AdjX.AsInteger, AdjY.AsInteger, AdjZ.AsInteger));
    end
    else if (CurPoly >= 0) then begin
      if CurVert < 0 then
        CurVert := 0;
      lbCoord.Items.Insert(CurVert, Format('%4d%4d%4d', [0, 0, 0]));
      InsertPoint(CurPoly, CurVert, Point3D(0, 0, 0));
    end
  end;
  FillUpData(LocalPiece);
  lbAllPolys.ItemIndex := CurPoly;
  lbCoord.ItemIndex := CurVert;
  FillVertexData(CurPoly);
  PaintBoxAddStdPaint(nil);
end;

procedure TAddHard.FormCreate(Sender: TObject);
begin
  fFileName := 'template.dat';
  fPartName := 'template';
  Shadow := TBitmap.Create;
  Shadow.PixelFormat := BitDepth;

  Shadow.Width := PaintBoxAddStd.Width;
  Shadow.Height := PaintBoxAddStd.Height;

  lScale := 1.0;
  btnRotLeft.Glyph.Assign(MainForm.btnRotLeft.Glyph);
  btnRotUp.Glyph.Assign(MainForm.btnRotUp.Glyph);
  btnRotRight.Glyph.Assign(MainForm.btnRotRight.Glyph);
  btnRotDown.Glyph.Assign(MainForm.btnRotDown.Glyph);
  btnZoomIn.Glyph.Assign(MainForm.btnZoomIn.Glyph);
  btnZoomOut.Glyph.Assign(MainForm.btnZoomOut.Glyph);
  btnWireBase.Glyph.Assign(MainForm.btnWireBase.Glyph);
  spbColor.Glyph.Assign(MainForm.btnColorDlg.Glyph);
  btnAddPolygon.Glyph.Assign(btnAddPiece.Glyph);
  btnAddVertex.Glyph.Assign(btnAddPiece.Glyph);
end;

procedure TAddHard.btnRotLeftClick(Sender: TObject);
begin
  lrz := lrz - 10 * DEG2RAD;
  if (lrz < 0.0) then
    lrz := pi * 2;
  PaintBoxAddStdPaint(nil)
end;

procedure TAddHard.btnRotUpClick(Sender: TObject);
begin
  lrx := lrx + 10 * DEG2RAD;
  if (lrx > 180 * DEG2RAD) then
    lrx := 180 * DEG2RAD;
  PaintBoxAddStdPaint(nil)
end;

procedure TAddHard.btnRotDownClick(Sender: TObject);
begin
  lrx := lrx - 10 * DEG2RAD;
  if (lrx < 0.0) then
    lrx := 0.0;
  PaintBoxAddStdPaint(nil)
end;

procedure TAddHard.btnRotRightClick(Sender: TObject);
begin
  lrz := lrz + 10 * DEG2RAD;
  if (lrz > pi * 2) then
    lrz := 0.0;
  PaintBoxAddStdPaint(nil)
end;

procedure TAddHard.btnZoomInClick(Sender: TObject);
begin
  lScale := lScale + 0.1;
  PaintBoxAddStdPaint(nil)
end;

procedure TAddHard.btnZoomOutClick(Sender: TObject);
begin
  lScale := lScale - 0.1;
  PaintBoxAddStdPaint(nil)
end;

procedure TAddHard.lbAllPolysMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  p                 : integer;
  i                 : integer;
  v                 : integer;
begin
  exit;
  if Button = mbRight then begin
    p := lbAllPolys.ItemAtPos(Point(x, y), False);
    if (p >= 0) then begin
      i := Abs(StrToInt(lbAllPolys.Items[p]));
      with TGeneralBlock(LocalPiece).DrawClass do begin
        begin
          case (Border[i - 1] and $1) of
            0: begin                    { has no own border - add it }
                Border[i - 1] := 1;
                v := i;
              end;
            1: begin                    { has border - remove it }
                Border[i - 1] := not 1;
                v := -i;
              end;
          end;
          lbCoord.Invalidate;
          lbAllPolys.Items[p] := IntToStr(v);
        end
      end;
      PaintBoxAddStdPaint(nil);
    end
  end
end;

procedure TAddHard.FormDestroy(Sender: TObject);
begin
  Shadow.Free;
end;

procedure TAddHard.spbColorClick(Sender: TObject);
begin
  if Assigned(LocalPiece) then begin
    if (CurPoly >= 0) and (lbAllPolys.ItemIndex >= 0) then begin
      with TGeneralBlock(LocalPiece).DrawClass do begin
        ColorDialog1.Color := Color[CurPoly];
        if ColorDialog1.Execute then
          Color[CurPoly] := ColorDialog1.Color;
      end
    end
  end
end;

procedure TAddHard.spbDet0Click(Sender: TObject);
begin
  DetailLevel := (Sender as TRxSpeedButton).Tag;
  PaintBoxAddStdPaint(nil);
end;

procedure TAddHard.cbDetailChange(Sender: TObject);
begin
  if Assigned(LocalPiece) and (CurPoly >= 0) and (lbAllPolys.ItemIndex >= 0) then begin
    with TGeneralBlock(LocalPiece).DrawClass do begin
      Detail[CurPoly] := StrToInt(cbDetail.Text);
    end
  end
end;

procedure TAddHard.btnExtrudeClick(Sender: TObject);
var
  cx, cy, cz        : integer;
  v, v1             : integer;
  Amt               : integer;
begin
  if Assigned(LocalPiece) and (CurPoly >= 0) then begin
    Amt := spExt.AsInteger;
    with TGeneralBlock(LocalPiece).DrawClass do begin
      cx := PolyPoint[CurPoly, 0].x;
      cy := PolyPoint[CurPoly, 0].y;
      cz := PolyPoint[CurPoly, 0].z;
      for v := 1 to Pred(NumPoints[CurPoly]) do begin
        if (PolyPoint[CurPoly, v].x <> cx) then cx := -9999;
        if (PolyPoint[CurPoly, v].y <> cy) then cy := -9999;
        if (PolyPoint[CurPoly, v].z <> cz) then cz := -9999;
      end;
      if (cx <> -9999) then begin       { constant x }
        for v := 0 to Pred(NumPoints[CurPoly]) do begin
          v1 := v + 1;
          if (v1 >= NumPoints[CurPoly]) then v1 := 0;
          AddPoly([Point3D(cx, PolyPoint[CurPoly, v].y, PolyPoint[CurPoly, v].z),
            Point3D(cx, PolyPoint[CurPoly, v1].y, PolyPoint[CurPoly, v1].z),
              Point3D(cx + Amt, PolyPoint[CurPoly, v1].y, PolyPoint[CurPoly, v1].z),
              Point3D(cx + Amt, PolyPoint[CurPoly, v].y, PolyPoint[CurPoly, v].z)]);
        end
      end
      else if (cy <> -9999) then begin  { constant y }
        for v := 0 to Pred(NumPoints[CurPoly]) do begin
          v1 := v + 1;
          if (v1 >= NumPoints[CurPoly]) then v1 := 0;
          AddPoly([Point3D(PolyPoint[CurPoly, v].x, cy, PolyPoint[CurPoly, v].z),
            Point3D(PolyPoint[CurPoly, v1].x, cy, PolyPoint[CurPoly, v1].z),
              Point3D(PolyPoint[CurPoly, v1].x, cy + Amt, PolyPoint[CurPoly, v1].z),
              Point3D(PolyPoint[CurPoly, v].x, cy + Amt, PolyPoint[CurPoly, v].z)]);
        end
      end
      else if (cz <> -9999) then begin  { constant z }
        for v := 0 to Pred(NumPoints[CurPoly]) do begin
          v1 := v + 1;
          if (v1 >= NumPoints[CurPoly]) then v1 := 0;
          AddPoly([Point3D(PolyPoint[CurPoly, v].x, PolyPoint[CurPoly, v].y, cz),
            Point3D(PolyPoint[CurPoly, v1].x, PolyPoint[CurPoly, v1].y, cz),
              Point3D(PolyPoint[CurPoly, v1].x, PolyPoint[CurPoly, v1].y, cz + Amt),
              Point3D(PolyPoint[CurPoly, v].x, PolyPoint[CurPoly, v].y, cz + Amt)]);
        end
      end;
      FillUpData(LocalPiece);
      PaintBoxAddStdPaint(nil);
    end
  end
end;

procedure TAddHard.pmSortClick(Sender: TObject);
var
  Oct               : integer;
  Oct0, Oct9        : integer;
  i, j, k           : integer;
  t                 : integer;
  DoSwap            : Boolean;
  pmin1, pmax1, pmin2, pmax2: TPoint3D;
  pmean1, pmean2    : TPoint3D;
  dmean1, dmean2    : TMyFloat;
begin
  { Sortera ritordningen }
  if (Sender as TComponent).Tag = 0 then begin
    Oct0 := speOctant.AsInteger;
    Oct9 := speOctant.AsInteger;
  end
  else begin
    Oct0 := 0;
    Oct9 := 7;
  end;

  for Oct := Oct0 to Oct9 do begin
    with TGeneralBlock(LocalPiece).DrawClass do begin
      for j := 0 to Pred(Pred(NumDrawFaces[Oct])) do begin
        for i := 0 to Pred(Pred(NumDrawFaces[Oct])) do begin
          (*
                    dmin1 := 999999;
                    dmin2 := 999999;
                    dmax1 := -999999;
                    dmax2 := -999999;
                    pmin1.x := 0;
                    pmin1.y := 0;
                    pmin1.z := 0;
                    for k := 0 to Pred(NumPoints[OrderedFace[Oct, i]]) do
                    begin
                      pmin1.x := pmin1.x + PolyPoint[OrderedFace[Oct, i], k].x;
                      pmin1.y := pmin1.y + PolyPoint[OrderedFace[Oct, i], k].y;
                      pmin1.z := pmin1.z + PolyPoint[OrderedFace[Oct, i], k].z;
                    end;
                    pmin1.x := pmin1.x div NumPoints[OrderedFace[Oct, i]];
                    pmin1.y := pmin1.y div NumPoints[OrderedFace[Oct, i]];
                    pmin1.z := pmin1.z div NumPoints[OrderedFace[Oct, i]];
                    dmin1 := MinValue([dmin1, Dist3(pmin1, EyePoints[Oct])]);
                    pmin2.x := 0;
                    pmin2.y := 0;
                    pmin2.z := 0;
                    for k := 0 to Pred(NumPoints[OrderedFace[Oct, i+1]]) do
                    begin
                      pmin2.x := pmin2.x + PolyPoint[OrderedFace[Oct, i+1], k].x;
                      pmin2.y := pmin2.y + PolyPoint[OrderedFace[Oct, i+1], k].y;
                      pmin2.z := pmin2.z + PolyPoint[OrderedFace[Oct, i+1], k].z;
                    end;
                    pmin2.x := pmin2.x div NumPoints[OrderedFace[Oct, i+1]];
                    pmin2.y := pmin2.y div NumPoints[OrderedFace[Oct, i+1]];
                    pmin2.z := pmin2.z div NumPoints[OrderedFace[Oct, i+1]];
                    dmin2 := MinValue([dmin2, Dist3(pmin2, EyePoints[Oct])]);
          *)
          (**)
          dmean1 := 99999;
          dmean2 := 99999;
          pmin1 := Point3D(9999, 9999, 9999);
          pmin2 := Point3D(9999, 9999, 9999);
          pmax1 := Point3D(-9999, -9999, -9999);
          pmax2 := Point3D(-9999, -9999, -9999);
          pmean1.x := 0;
          pmean1.y := 0;
          pmean1.z := 0;
          pmean2.x := 0;
          pmean2.y := 0;
          pmean2.z := 0;
          for k := 0 to Pred(NumPoints[OrderedFace[Oct, i]]) do begin
            pmin1.x := Min(pmin1.x, PolyPoint[OrderedFace[Oct, i], k].x);
            pmin1.y := Min(pmin1.y, PolyPoint[OrderedFace[Oct, i], k].y);
            pmin1.z := Min(pmin1.z, PolyPoint[OrderedFace[Oct, i], k].z);
            pmax1.x := Max(pmax1.x, PolyPoint[OrderedFace[Oct, i], k].x);
            pmax1.y := Max(pmax1.y, PolyPoint[OrderedFace[Oct, i], k].y);
            pmax1.z := Max(pmax1.z, PolyPoint[OrderedFace[Oct, i], k].z);
            pmean1.x := pmean1.x + PolyPoint[OrderedFace[Oct, i], k].x;
            pmean1.y := pmean1.y + PolyPoint[OrderedFace[Oct, i], k].y;
            pmean1.z := pmean1.z + PolyPoint[OrderedFace[Oct, i], k].z;
          end;
          pmean1.x := pmean1.x div NumPoints[OrderedFace[Oct, i]];
          pmean1.y := pmean1.y div NumPoints[OrderedFace[Oct, i]];
          pmean1.z := pmean1.z div NumPoints[OrderedFace[Oct, i]];
          dmean1 := MinValue([dmean1, Dist3(pmean1, EyePoints[Oct])]);
          for k := 0 to Pred(NumPoints[OrderedFace[Oct, i + 1]]) do begin
            pmin2.x := Min(pmin2.x, PolyPoint[OrderedFace[Oct, i + 1], k].x);
            pmin2.y := Min(pmin2.y, PolyPoint[OrderedFace[Oct, i + 1], k].y);
            pmin2.z := Min(pmin2.z, PolyPoint[OrderedFace[Oct, i + 1], k].z);
            pmax2.x := Max(pmax2.x, PolyPoint[OrderedFace[Oct, i + 1], k].x);
            pmax2.y := Max(pmax2.y, PolyPoint[OrderedFace[Oct, i + 1], k].y);
            pmax2.z := Max(pmax2.z, PolyPoint[OrderedFace[Oct, i + 1], k].z);
            pmean2.x := pmean2.x + PolyPoint[OrderedFace[Oct, i + 1], k].x;
            pmean2.y := pmean2.y + PolyPoint[OrderedFace[Oct, i + 1], k].y;
            pmean2.z := pmean2.z + PolyPoint[OrderedFace[Oct, i + 1], k].z;
          end;
          pmean2.x := pmean2.x div NumPoints[OrderedFace[Oct, i + 1]];
          pmean2.y := pmean2.y div NumPoints[OrderedFace[Oct, i + 1]];
          pmean2.z := pmean2.z div NumPoints[OrderedFace[Oct, i + 1]];
          dmean2 := MinValue([dmean2, Dist3(pmean2, EyePoints[Oct])]);
          (*
                              (x:-1000; y:1000; z:1000),
                              (x:-1000; y:-1000; z:1000),
                              (x:1000; y:-1000; z:1000),
                              (x:1000; y:1000; z:1000),
                              (x:-1000; y:1000; z:-1000),
                              (x:-1000; y:-1000; z:-1000),
                              (x:1000; y:-1000; z:-1000),
                              (x:1000; y:1000; z:-1000)
          *)
          case Oct of
            0: DoSwap := (pmax1.x <= pmin2.x) or (pmin1.y >= pmax2.y) or (pmin1.z >= pmax2.z);
            1: DoSwap := (pmax1.x <= pmin2.x) or (pmax1.y <= pmin2.y) or (pmin1.z >= pmax2.z);
            2: DoSwap := (pmin1.x >= pmax2.x) or (pmax1.y <= pmin2.y) or (pmin1.z >= pmax2.z);
            3: DoSwap := (pmin1.x >= pmax2.x) or (pmin1.y >= pmax2.y) or (pmin1.z >= pmax2.z);
            4: DoSwap := (pmax1.x <= pmin2.x) or (pmin1.y >= pmax2.y) or (pmax1.z <= pmin2.z);
            5: DoSwap := (pmax1.x <= pmin2.x) or (pmax1.y <= pmin2.y) or (pmax1.z <= pmin2.z);
            6: DoSwap := (pmin1.x >= pmax2.x) or (pmax1.y <= pmin2.y) or (pmax1.z <= pmin2.z);
            7: DoSwap := (pmin1.x >= pmax2.x) or (pmin1.y >= pmax2.y) or (pmax1.z <= pmin2.z);
            else
              DoSwap := dmean1 < dmean2; //False;
          end;
          (**)
          (*
                    DoSwap := (dMin2 < dMin1);
          *)
          if DoSwap then begin
            t := OrderedFace[Oct, i];
            OrderedFace[Oct, i] := OrderedFace[Oct, i + 1];
            OrderedFace[Oct, i + 1] := t;
          end
        end
      end
    end
  end;
  FillUpData(LocalPiece);
  PaintBoxAddStdPaint(nil);
end;

procedure TAddHard.mmMirrorXClick(Sender: TObject);
var
  i, j              : integer;
  t1                : TPoint3D;
  mx, my, mz        : integer;
  p0, p9            : integer;
begin

  with TGeneralBlock(LocalPiece).DrawClass do begin
    mx := -9999;
    my := -9999;
    mz := -9999;

    case (Sender as TComponent).Tag of
      0, 1, 2: begin
          if CurPoly >= 0 then begin
            p0 := CurPoly;
            p9 := CurPoly;
          end
          else begin
            Exit;
          end
        end;
      3, 4, 5: begin
          p0 := 0;
          p9 := Pred(NumPolys);
        end;
      else begin
          p0 := 0;
          p9 := 0;
        end
    end;

    for i := 0 to Pred(NumPolys) do begin
      for j := 0 to Pred(NumPoints[i]) do begin
        t1 := PolyPoint[i, j];
        mx := Max(mx, t1.x);
        my := Max(my, t1.y);
        mz := Max(mz, t1.z);
      end
    end;
    mx := ((mx + 19) div 20) * 20;
    for i := p0 to p9 do begin
      for j := 0 to Pred(NumPoints[i]) do begin
        t1 := PolyPoint[i, j];
        case (Sender as TComponent).Tag of
          0, 3: t1.x := mx - t1.x;
          1, 4: t1.y := my - t1.y;
          2, 5: t1.z := mz - t1.z;
        end;
        PolyPoint[i, j] := t1;
      end
    end
  end;
  pmSortClick(mmSortAll);
  PaintBoxAddStdPaint(nil);
  if CurPoly >= 0 then
    FillVertexData(CurPoly);
end;

procedure TAddHard.PopupMenu2Popup(Sender: TObject);
begin
  if CurPoly > 0 then begin
    TransparentOpaque1.Enabled := True;
    Border1.Enabled := True;
    Delete1.Enabled := True;
    with TGeneralBlock(LocalPiece).DrawClass do begin
      begin
        TransparentOpaque1.Checked := (Color[CurPoly] < 0);
        Border1.Checked := (Border[CurPoly] and $1) <> 0;
      end
    end
  end
  else begin
    TransparentOpaque1.Enabled := False;
    Border1.Enabled := False;
    Delete1.Enabled := False;
  end
end;

procedure TAddHard.TransparentOpaque1Click(Sender: TObject);
var
  p, i              : integer;
begin
  p := lbAllPolys.ItemIndex;
  if (p >= 0) then begin
    i := Abs(StrToInt(lbAllPolys.Items[p]));
    with TGeneralBlock(LocalPiece).DrawClass do begin
      begin
        if Color[i - 1] <> 0 then begin
          Color[i - 1] := -Color[i - 1];
          if (Color[i - 1] = clWhite) then // Assume the color should be default
            Color[i - 1] := clBlack;
        end
        else begin
          Color[i - 1] := -clWhite;
        end
      end
    end;
    PaintBoxAddStdPaint(nil);
  end
end;

procedure TAddHard.Border1Click(Sender: TObject);
var
  p, i, v           : integer;
begin
  p := lbAllPolys.ItemIndex;
  if (p >= 0) then begin
    i := Abs(StrToInt(lbAllPolys.Items[p]));
    with TGeneralBlock(LocalPiece).DrawClass do begin
      begin
        case (Border[i - 1] and $1) of
          0: begin                      { has no own border - add it }
              Border[i - 1] := 1;
              v := i;
            end;
          1: begin                      { has border - remove it }
              Border[i - 1] := not 1;
              v := -i;
            end;
          else
            v := 0;
        end;
        lbCoord.Invalidate;
        lbAllPolys.Items[p] := IntToStr(v);
        lbAllPolys.ItemIndex := p;
      end
    end;
    PaintBoxAddStdPaint(nil);
  end
end;

procedure TAddHard.lbCoordMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  p                 : integer;
begin
  if (Button = mbRight) and (CurPoly >= 0) then begin
    p := lbCoord.ItemAtPos(Point(x, y), False);
    //    DebugPrint(Format('P = %d', [p]));
    if (p >= 0) and (p < 31) then begin
      with TGeneralBlock(LocalPiece).DrawClass do begin
        begin
          Border[CurPoly] := (Border[CurPoly] and $FFFFFFFE) xor (1 shl (p + 1));
          if (Border[CurPoly] and $FFFFFFFE) = 0 then
            Border[CurPoly] := 1;
          //          DebugPrint(Format('B = %x', [Border[CurPoly]]));
          lbCoord.Invalidate;
        end
      end;
      PaintBoxAddStdPaint(nil);
    end
  end
end;

procedure TAddHard.lbCoordDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  with (Control as TListBox) do begin
    Canvas.TextRect(Rect, 8, (Index - TopIndex) * ItemHeight, lbCoord.Items[Index]);
    if Assigned(LocalPiece) and (CurPoly >= 0) then begin
      with TGeneralBlock(LocalPiece).DrawClass do begin
        if ((Border[CurPoly] and 1) = 1) or
          ((Border[CurPoly] and (1 shl (Index + 1))) = 0) then begin
          Canvas.MoveTo(5, (Index - TopIndex) * ItemHeight + 1);
          Canvas.LineTo(5, (Index - TopIndex + 1) * ItemHeight);
          Canvas.Pixels[4, (Index - TopIndex + 1) * ItemHeight - 2] := clBlack;
          Canvas.Pixels[6, (Index - TopIndex + 1) * ItemHeight - 2] := clBlack;
          Canvas.Pixels[3, (Index - TopIndex + 1) * ItemHeight - 3] := clBlack;
          Canvas.Pixels[7, (Index - TopIndex + 1) * ItemHeight - 3] := clBlack;
        end
      end
    end;
  end;
end;

procedure TAddHard.Panel5Resize(Sender: TObject);
begin
  lbAllPolys.Height := Panel6.Top - lbAllPolys.Top;
  lbDrawOrder.Height := Panel6.Top - lbAllPolys.Top;
  lbCoord.Height := Panel6.Top - lbAllPolys.Top;
end;

procedure TAddHard.lbCoordKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    'a', 'A': AdjX.AsInteger := AdjX.Asinteger + 1;
    's', 'S': AdjY.AsInteger := AdjY.Asinteger + 1;
    'd', 'D': AdjZ.AsInteger := AdjZ.Asinteger + 1;
    'z', 'Z': AdjX.AsInteger := AdjX.Asinteger - 1;
    'x', 'X': AdjY.AsInteger := AdjY.Asinteger - 1;
    'c', 'C': AdjZ.AsInteger := AdjZ.Asinteger - 1;
  end;
  AdjXChange(nil);
  Key := #0;
end;

procedure TAddHard.edtXKeyPress(Sender: TObject; var Key: Char);
begin
  if (lbBlockTypes.ItemIndex = 8) then begin {General block}
    Key := #0;
  end
end;

procedure TAddHard.mmRotateXClick(Sender: TObject);
var
  i, j              : integer;
  t1, t2            : TPoint3D;
  x0, y0, z0        : integer;
  x5, y5, z5        : integer;
  x6, y6, z6        : integer;
  x9, y9, z9        : integer;
  pl1, pb1, ph1     : integer;
  p0, p9            : integer;
begin

  with TGeneralBlock(LocalPiece).DrawClass do begin
    x0 := 32000;
    y0 := 32000;
    z0 := 32000;
    x6 := 0;
    y6 := 0;
    z6 := 0;
    pl1 := 0;
    pb1 := 0;
    ph1 := 0;
    x9 := -32000;
    y9 := -32000;
    z9 := -32000;

    case (Sender as TComponent).Tag of
      0, 1, 2: begin
          if CurPoly >= 0 then begin
            p0 := CurPoly;
            p9 := CurPoly;
          end
          else begin
            Exit;
          end
        end;
      3, 4, 5: begin
          p0 := 0;
          p9 := Pred(NumPolys);
        end;
      else
        Exit;
    end;
    for i := p0 to p9 do begin
      for j := 0 to Pred(NumPoints[i]) do begin
        t1 := PolyPoint[i, j];
        x0 := Min(x0, t1.x);
        y0 := Min(y0, t1.y);
        z0 := Min(z0, t1.z);
        x9 := Max(x9, t1.x);
        y9 := Max(y9, t1.y);
        z9 := Max(z9, t1.z);
      end;
    end;

    x5 := x0 + (x9 - x0) div 2;
    y5 := y0 + (y9 - y0) div 2;
    z5 := z0 + (z9 - z0) div 2;

    try
      InternalHold := True;
      with LocalPiece do begin
        case (Sender as TComponent).Tag of
          3: begin
              pl1 := pl;
              pb1 := ph;
              ph1 := pb;
              x6 := x5;
              y6 := z5;
              z6 := y5;
            end;
          4: begin
              pl1 := ph;
              pb1 := pb;
              ph1 := pl;
              x6 := z5;
              y6 := y5;
              z6 := x5;
            end;
          5: begin
              pl1 := pb;
              pb1 := pl;
              ph1 := ph;
              x6 := y5;
              y6 := x5;
              z6 := z5;
            end;
        end;

        pl := pl1;
        pb := pb1;
        ph := ph1;

        SetLBH(pl1, pb1, ph1);
        edtX.AsInteger := pl1;
        edtY.AsInteger := pb1;
        edtZ.AsInteger := ph1;

        edtXShadow := pl1;
        edtYShadow := pb1;
        edtZShadow := ph1;
      end;
    finally
      InternalHold := False;
    end;

    for i := p0 to p9 do begin
      for j := 0 to Pred(NumPoints[i]) do begin
        t1 := PolyPoint[i, j];
        t1.x := t1.x - x5;
        t1.y := t1.y - y5;
        t1.z := t1.z - z5;
        t2 := t1;
        case (Sender as TComponent).Tag of
          0, 3: begin
              t2.y := t1.z;
              t2.z := t1.y;
            end;
          1, 4: begin
              t2.x := t1.z;
              t2.z := t1.x;
            end;
          2, 5: begin
              t2.y := t1.x;
              t2.x := t1.y;
            end;
        end;
        t2.x := t2.x + x6;
        t2.y := t2.y + y6;
        t2.z := t2.z + z6;
        PolyPoint[i, j] := t2;
      end
    end;
  end;
  pmSortClick(mmSortAll);
  PaintBoxAddStdPaint(nil);
  if CurPoly >= 0 then
    FillVertexData(CurPoly);
end;

procedure TAddHard.lbAllPolysKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then
    Delete1Click(nil);
end;

var
  mx, my            : integer;

procedure TAddHard.PaintBoxAddStdMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Shift = [ssShift, ssRight]) then begin
    mx := x;
    my := y;
  end;
end;

procedure TAddHard.PaintBoxAddStdMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Shift = [ssShift, ssRight]) then begin
    if (Abs(x - mx) > 10) or (Abs(y - my) > 10) then begin

      if (x - mx) < -10 then begin
        lrz := lrz - 10 * DEG2RAD;
        if (lrz < 0.0) then
          lrz := pi * 2;
      end
      else if (x - mx) > 10 then begin
        lrz := lrz + 10 * DEG2RAD;
        if (lrz > pi * 2) then
          lrz := 0;
      end;

      if (y - my) > 10 then begin
        lrx := lrx - 10 * DEG2RAD;
        if (lrx < 0) then
          lrx := 0;
      end
      else if (y - my) < -10 then begin
        lrx := lrx + 10 * DEG2RAD;
        if (lrx > 180 * DEG2RAD) then
          lrx := 180 * DEG2RAD;
      end;
      PaintBoxAddStdPaint(nil);
      mx := x;
      my := y;
    end
  end
end;

procedure TAddHard.mmScaleZ4Click(Sender: TObject);
var
  i, j              : integer;
  p                 : TPoint3D;
  //  ls, bs, hs        : integer;
  ScaleType         : integer;
begin
  ScaleType := TMenuItem(Sender).Tag;
  with TGeneralBlock(LocalPiece), DrawClass do begin
    if ScaleType < 0 then begin         { Z }
      ScaleType := -ScaleType;
      //      hs := ph div 2;
      for i := 0 to Pred(NumPolys) do begin
        for j := 0 to Pred(NumPoints[i]) do begin
          p := PolyPoint[i, j];
          p.z := p.z * ScaleType;
          PolyPoint[i, j] := p;
        end
      end;
      ph := ph * ScaleType;
    end
    else begin
      //      ls := pl div 2;
      //      bs := pb div 2;
      //      hs := ph div 2;
      for i := 0 to Pred(NumPolys) do begin
        for j := 0 to Pred(NumPoints[i]) do begin
          p := PolyPoint[i, j];
          p.x := p.x * ScaleType;
          p.y := p.y * ScaleType;
          PolyPoint[i, j] := p;
        end
      end;
      pl := pl * ScaleType;
      pb := pb * ScaleType;
    end;
    (*---------------------------------------------------------------*)
    InternalHold := True;
    try
      edtX.AsInteger := pl;
      edtY.AsInteger := pb;
      edtZ.AsInteger := ph;
    finally
      InternalHold := False;
    end;
    SetLBH(pl, pb, ph);
    if cbAutoStuds.Checked then
      GenerateStuds(pl, pb, ph);
    if (lbDrawOrder.ItemIndex >= 0) then begin
      px := StrToInt(lbDrawOrder.Items[lbDrawOrder.ItemIndex]) - 1;
      if (px >= 0) then begin
        FillVertexData(px);
      end;
    end;
    PaintBoxAddStdPaint(nil);
  end
end;

procedure TAddHard.mmScaleZd2Click(Sender: TObject);
var
  i, j              : integer;
  p                 : TPoint3D;
  //  ls, bs, hs        : integer;
  ScaleType         : integer;
begin
  ScaleType := TMenuItem(Sender).Tag;
  with TGeneralBlock(LocalPiece), DrawClass do begin
    if ScaleType < 0 then begin         { Z }
      ScaleType := -ScaleType;
      //      hs := ph div 2;
      for i := 0 to Pred(NumPolys) do begin
        for j := 0 to Pred(NumPoints[i]) do begin
          p := PolyPoint[i, j];
          p.z := p.z div ScaleType;
          PolyPoint[i, j] := p;
        end
      end;
      ph := ph div ScaleType;
    end
    else begin
      //      ls := pl div 2;
      //      bs := pb div 2;
      //      hs := ph div 2;
      for i := 0 to Pred(NumPolys) do begin
        for j := 0 to Pred(NumPoints[i]) do begin
          p := PolyPoint[i, j];
          p.x := p.x div ScaleType;
          p.y := p.y div ScaleType;
          PolyPoint[i, j] := p;
        end
      end;
      pl := pl div ScaleType;
      pb := pb div ScaleType;
    end;
    (*---------------------------------------------------------------*)
    InternalHold := True;
    try
      edtX.AsInteger := pl;
      edtY.AsInteger := pb;
      edtZ.AsInteger := ph;
    finally
      InternalHold := False;
    end;
    SetLBH(pl, pb, ph);
    if cbAutoStuds.Checked then
      GenerateStuds(pl, pb, ph);
    if (lbDrawOrder.ItemIndex >= 0) then begin
      px := StrToInt(lbDrawOrder.Items[lbDrawOrder.ItemIndex]) - 1;
      if (px >= 0) then begin
        FillVertexData(px);
      end;
    end;
    PaintBoxAddStdPaint(nil);
  end
end;

procedure TAddHard.cbAutoStudsClick(Sender: TObject);
begin
  if LocalPiece is TGeneralBlock then begin
    if cbAutoStuds.Checked then begin
      with TGeneralBlock(LocalPiece), DrawClass do
        GenerateStuds(pl, pb, ph);
    end
    else begin
      with TGeneralBlock(LocalPiece), DrawClass do
        RemoveTopStuds;
    end
  end;
  PaintBoxAddStdPaint(nil);
end;

end.

